=== debian/tests/control ===
Test-Command: ./debian/tests/variants --version
Depends: @
Restrictions: superficial

Test-Command: ./debian/tests/upstreamtest /usr/bin/vim
Depends: vim
Restrictions: needs-root, allow-stderr, flaky

Test-Command: ./debian/tests/upstreamtest /usr/bin/vim
Depends: vim-nox
Restrictions: needs-root, allow-stderr, flaky

Test-Command: ./debian/tests/upstreamtest /usr/bin/vi
Depends: vim-tiny
Restrictions: needs-root, allow-stderr, flaky
